#pragma once
// mostly autogenerated by tools/hslt/Makefile

static inline float ipow(const float x, int exp)
{
  if(exp <  0) return 1.0f/ipow(x, -exp);
  if(exp == 0) return 1.0f;
  if(exp == 1) return x;
  if(exp == 2) return x*x;
  const float p2 = ipow(x, exp/2);
  if(exp &  1) return x * p2 * p2;
  return p2 * p2;
}

static inline float manifold_vol_dhu_du(const char m, const float *wi, const float *wo, const float lwi, const float lwo, const float *u, const float scramble)
{
  const int up = fabsf(wi[1]/lwi) < scramble;
  const float wi0 = wi[0], wi1 = wi[1], wi2 = wi[2], wo0 = wo[0], wo1 = wo[1], wo2 = wo[2];
  const float u0 = u[0], u1 = u[1], u2 = u[2];
  switch(m)
  {
    case 'a':
      if(up)
      {
        const float v1=(lwi),v2=ipow(wi0,2),v3=ipow(wi2,2),v4=(lwo),v5=ipow(lwi,2),v6=ipow(wi0,3),v7=ipow(wo0,2),v8=ipow(wi0,4),v9=ipow(wi2,3),v10=ipow(wi2,4),v11=ipow(wi1,2),v12=ipow(wo2,2);
        return -((-v5*u2*wi0*wi1*wi2*wo1*wo2)+u2*v6*wi1*wi2*wo1*wo2+u0*v8*wi1*wo1*wo2+u2*wi0*wi1*v9*wo1*wo2-v5*u1*v6*wo1*wo2+u0*v2*wi1*v3*wo1*wo2+v5*u0*wi1*v3*wo1*wo2-v5*u1*wi0*v3*wo1*wo2+u1*wi0*v11*v3*wo1*wo2+u1*v6*v11*wo1*wo2-u2*ipow(wi2,5)*wo0*wo2+u2*v8*wi2*wo0*wo2-v5*u2*v2*wi2*wo0*wo2+u1*v8*wi1*wo0*wo2+u0*ipow(wi0,5)*wo0*wo2+v5*u2*v9*wo0*wo2-v5*u0*v6*wo0*wo2+v5*u0*wi0*v3*wo0*wo2-u1*wi1*v10*wo0*wo2-u0*wi0*v10*wo0*wo2-v5*v1*v4*u2*wi0*wi2*wo2+v5*v1*v4*u0*v3*wo2+v5*u0*wi0*wi1*wi2*wo0*wo1-u0*v6*wi1*wi2*wo0*wo1+v5*u1*v2*wi2*wo0*wo1-u1*v2*v11*wi2*wo0*wo1-v5*u2*v2*wi1*wo0*wo1-u0*wi0*wi1*v9*wo0*wo1-u1*v11*v9*wo0*wo1+v5*u1*v9*wo0*wo1-u2*v2*wi1*v3*wo0*wo1-u2*wi1*v10*wo0*wo1+v5*v1*v4*u0*wi0*wi2*wo0-v5*v1*v4*u2*v2*wo0-u1*v6*wi1*wi2*v7-u0*v8*wi2*v7+2*v5*u0*v2*wi2*v7-u1*wi0*wi1*v9*v7-u0*v2*v9*v7+v5*u0*v9*v7-v5*u2*v6*v7-u2*v6*v3*v7-u2*wi0*v10*v7+u1*v6*wi1*wi2*v12+u0*v8*wi2*v12+u1*wi0*wi1*v9*v12+u0*v2*v9*v12+v5*u0*v9*v12-v5*u2*v6*v12-2*v5*u2*wi0*v3*v12+u2*v6*v3*v12+u2*wi0*v10*v12)/(v1*ipow(sqrt(v3+v2),3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v1*v4,2));
      }
      else
      {
        const float v1=(lwi),v2=ipow(wi1,2),v3=ipow(wi2,2),v4=(lwo),v5=ipow(lwi,2),v6=ipow(wi0,2),v7=ipow(wi1,3),v8=ipow(wi2,3),v9=ipow(wi2,4),v10=ipow(wo1,2),v11=ipow(wi1,4),v12=ipow(wo2,2);
        return ((-u2*ipow(wi2,5)*wo1*wo2)-v5*u2*v2*wi2*wo1*wo2+u2*v11*wi2*wo1*wo2+u1*ipow(wi1,5)*wo1*wo2-u1*wi1*v9*wo1*wo2-u0*wi0*v9*wo1*wo2+v5*u2*v8*wo1*wo2-v5*u1*v7*wo1*wo2+v5*u1*wi1*v3*wo1*wo2+u0*wi0*v11*wo1*wo2-v5*u2*wi0*wi1*wi2*wo0*wo2+u2*wi0*v7*wi2*wo0*wo2+u2*wi0*wi1*v8*wo0*wo2+u0*v6*v7*wo0*wo2-v5*u0*v7*wo0*wo2+u0*v6*wi1*v3*wo0*wo2-v5*u0*wi1*v3*wo0*wo2+v5*u1*wi0*v3*wo0*wo2+u1*wi0*v2*v3*wo0*wo2+u1*wi0*v11*wo0*wo2-v5*v1*v4*u2*wi1*wi2*wo2+v5*v1*v4*u1*v3*wo2+v5*u1*wi0*wi1*wi2*wo0*wo1-u1*wi0*v7*wi2*wo0*wo1-u0*v6*v2*wi2*wo0*wo1+v5*u0*v2*wi2*wo0*wo1-u2*wi0*v9*wo0*wo1-u1*wi0*wi1*v8*wo0*wo1-u0*v6*v8*wo0*wo1+v5*u0*v8*wo0*wo1-u2*wi0*v2*v3*wo0*wo1-v5*u2*wi0*v2*wo0*wo1+v5*v1*v4*u1*wi1*wi2*wo1-v5*v1*v4*u2*v2*wo1+u0*wi0*v7*wi2*v12+u1*v11*wi2*v12+u2*wi1*v9*v12+u0*wi0*wi1*v8*v12+u1*v2*v8*v12+v5*u1*v8*v12-v5*u2*v7*v12-2*v5*u2*wi1*v3*v12+u2*v7*v3*v12-u0*wi0*v7*wi2*v10+2*v5*u1*v2*wi2*v10-u1*v11*wi2*v10-u2*wi1*v9*v10-u0*wi0*wi1*v8*v10-u1*v2*v8*v10+v5*u1*v8*v10-v5*u2*v7*v10-u2*v7*v3*v10)/(v1*ipow(sqrt(v3+v2),3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v1*v4,2));
      }
    default: case 'b':
      if(up)
      {
        const float v1=(lwi),v2=ipow(lwo,2),v3=ipow(wi0,2),v4=ipow(wi2,2),v5=(lwo),v6=ipow(lwi,2),v7=ipow(wi0,3),v8=ipow(wi2,3),v9=ipow(wi0,4),v10=ipow(wi2,4),v11=ipow(wo0,2),v12=ipow(wi1,2),v13=ipow(wo2,2);
        return ((-v6*v2*u2*wi0*wi1*wi2*wo1*wo2)+v2*u2*v7*wi1*wi2*wo1*wo2+v2*u0*v9*wi1*wo1*wo2+v2*u2*wi0*wi1*v8*wo1*wo2+v6*v1*v5*u1*v7*wo1*wo2-v6*v2*u1*v7*wo1*wo2+v2*u0*v3*wi1*v4*wo1*wo2+v6*v2*u0*wi1*v4*wo1*wo2+v6*v1*v5*u1*wi0*v4*wo1*wo2-v6*v2*u1*wi0*v4*wo1*wo2+v2*u1*wi0*v12*v4*wo1*wo2+v2*u1*v7*v12*wo1*wo2-u2*v2*ipow(wi2,5)*wo0*wo2+v2*u2*v9*wi2*wo0*wo2-v6*v1*v5*u2*v3*wi2*wo0*wo2-v6*v2*u2*v3*wi2*wo0*wo2+v2*u1*v9*wi1*wo0*wo2+u0*v2*ipow(wi0,5)*wo0*wo2-v6*v1*v5*u2*v8*wo0*wo2+v6*v2*u2*v8*wo0*wo2+v6*v1*v5*u0*v7*wo0*wo2-v6*v2*u0*v7*wo0*wo2+v6*v1*v5*u0*wi0*v4*wo0*wo2+v6*v2*u0*wi0*v4*wo0*wo2-v2*u1*wi1*v10*wo0*wo2-v2*u0*wi0*v10*wo0*wo2-v6*v1*v2*v5*u2*wi0*wi2*wo2+v6*v2*u1*v7*wi1*wo2+v6*v2*u0*v9*wo2+v6*v2*u1*wi0*wi1*v4*wo2+2*v6*v2*u0*v3*v4*wo2+v6*v1*v2*v5*u0*v4*wo2+v6*v2*u0*v10*wo2+v6*v2*u0*wi0*wi1*wi2*wo0*wo1-v2*u0*v7*wi1*wi2*wo0*wo1-v6*v1*v5*u1*v3*wi2*wo0*wo1+v6*v2*u1*v3*wi2*wo0*wo1-v2*u1*v3*v12*wi2*wo0*wo1-v6*v2*u2*v3*wi1*wo0*wo1-v2*u0*wi0*wi1*v8*wo0*wo1-v2*u1*v12*v8*wo0*wo1-v6*v1*v5*u1*v8*wo0*wo1+v6*v2*u1*v8*wo0*wo1-v2*u2*v3*wi1*v4*wo0*wo1-v2*u2*wi1*v10*wo0*wo1+v6*v2*u0*v3*wi1*wi2*wo1-v6*v2*u2*v7*wi1*wo1+v6*v2*u0*wi1*v8*wo1-v6*v2*u2*wi0*wi1*v4*wo1-v6*v2*u1*v3*wi1*wi2*wo0+v6*v1*v2*v5*u0*wi0*wi2*wo0-v6*v2*u2*v9*wo0-v6*v2*u1*wi1*v8*wo0-2*v6*v2*u2*v3*v4*wo0-v6*v1*v2*v5*u2*v3*wo0-v6*v2*u2*v10*wo0+v6*v1*v2*v5*u0*v3*wi2+v6*v1*v2*v5*u0*v8-v6*v1*v2*v5*u2*v7-v6*v1*v2*v5*u2*wi0*v4+v2*u1*v7*wi1*wi2*v13+v2*u0*v9*wi2*v13+v2*u1*wi0*wi1*v8*v13+v2*u0*v3*v8*v13+v6*v2*u0*v8*v13+v6*v1*v5*u2*v7*v13-v6*v2*u2*v7*v13+v6*v1*v5*u2*wi0*v4*v13-2*v6*v2*u2*wi0*v4*v13+v2*u2*v7*v4*v13+v2*u2*wi0*v10*v13-v2*u1*v7*wi1*wi2*v11-v2*u0*v9*wi2*v11-v6*v1*v5*u0*v3*wi2*v11+2*v6*v2*u0*v3*wi2*v11-v2*u1*wi0*wi1*v8*v11-v2*u0*v3*v8*v11-v6*v1*v5*u0*v8*v11+v6*v2*u0*v8*v11-v6*v2*u2*v7*v11-v2*u2*v7*v4*v11-v2*u2*wi0*v10*v11)/(v1*v2*ipow(sqrt(v4+v3),3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v1*v5,2));
      }
      else
      {
        const float v1=(lwi),v2=ipow(lwo,2),v3=ipow(wi1,2),v4=ipow(wi2,2),v5=(lwo),v6=ipow(lwi,2),v7=ipow(wi1,3),v8=ipow(wi2,3),v9=ipow(wi1,4),v10=ipow(wi2,4),v11=ipow(wi0,2),v12=ipow(wo1,2),v13=ipow(wo2,2);
        return -((-u2*v2*ipow(wi2,5)*wo1*wo2)+v2*u2*v9*wi2*wo1*wo2-v6*v1*v5*u2*v3*wi2*wo1*wo2-v6*v2*u2*v3*wi2*wo1*wo2+u1*v2*ipow(wi1,5)*wo1*wo2+v2*u0*wi0*v9*wo1*wo2-v6*v1*v5*u2*v8*wo1*wo2+v6*v2*u2*v8*wo1*wo2+v6*v1*v5*u1*v7*wo1*wo2-v6*v2*u1*v7*wo1*wo2+v6*v1*v5*u1*wi1*v4*wo1*wo2+v6*v2*u1*wi1*v4*wo1*wo2-v2*u1*wi1*v10*wo1*wo2-v2*u0*wi0*v10*wo1*wo2-v6*v2*u2*wi0*wi1*wi2*wo0*wo2+v2*u2*wi0*v7*wi2*wo0*wo2+v2*u1*wi0*v9*wo0*wo2+v2*u2*wi0*wi1*v8*wo0*wo2+v2*u0*v11*v7*wo0*wo2+v6*v1*v5*u0*v7*wo0*wo2-v6*v2*u0*v7*wo0*wo2+v2*u0*v11*wi1*v4*wo0*wo2+v6*v1*v5*u0*wi1*v4*wo0*wo2-v6*v2*u0*wi1*v4*wo0*wo2+v6*v2*u1*wi0*v4*wo0*wo2+v2*u1*wi0*v3*v4*wo0*wo2-v6*v1*v2*v5*u2*wi1*wi2*wo2+v6*v2*u1*v9*wo2+v6*v2*u0*wi0*v7*wo2+v6*v2*u0*wi0*wi1*v4*wo2+2*v6*v2*u1*v3*v4*wo2+v6*v1*v2*v5*u1*v4*wo2+v6*v2*u1*v10*wo2+v6*v2*u1*wi0*wi1*wi2*wo0*wo1-v2*u1*wi0*v7*wi2*wo0*wo1-v2*u0*v11*v3*wi2*wo0*wo1-v6*v1*v5*u0*v3*wi2*wo0*wo1+v6*v2*u0*v3*wi2*wo0*wo1-v2*u1*wi0*wi1*v8*wo0*wo1-v2*u0*v11*v8*wo0*wo1-v6*v1*v5*u0*v8*wo0*wo1+v6*v2*u0*v8*wo0*wo1-v2*u2*wi0*v3*v4*wo0*wo1-v6*v2*u2*wi0*v3*wo0*wo1-v2*u2*wi0*v10*wo0*wo1+v6*v1*v2*v5*u1*wi1*wi2*wo1-v6*v2*u0*wi0*v3*wi2*wo1-v6*v2*u2*v9*wo1-v6*v2*u0*wi0*v8*wo1-2*v6*v2*u2*v3*v4*wo1-v6*v1*v2*v5*u2*v3*wo1-v6*v2*u2*v10*wo1+v6*v2*u1*wi0*v3*wi2*wo0+v6*v2*u1*wi0*v8*wo0-v6*v2*u2*wi0*v7*wo0-v6*v2*u2*wi0*wi1*v4*wo0+v6*v1*v2*v5*u1*v3*wi2+v6*v1*v2*v5*u1*v8-v6*v1*v2*v5*u2*v7-v6*v1*v2*v5*u2*wi1*v4+v2*u1*v9*wi2*v13+v2*u0*wi0*v7*wi2*v13+v2*u0*wi0*wi1*v8*v13+v2*u1*v3*v8*v13+v6*v2*u1*v8*v13+v6*v1*v5*u2*v7*v13-v6*v2*u2*v7*v13+v6*v1*v5*u2*wi1*v4*v13-2*v6*v2*u2*wi1*v4*v13+v2*u2*v7*v4*v13+v2*u2*wi1*v10*v13-v2*u1*v9*wi2*v12-v2*u0*wi0*v7*wi2*v12-v6*v1*v5*u1*v3*wi2*v12+2*v6*v2*u1*v3*wi2*v12-v2*u0*wi0*wi1*v8*v12-v2*u1*v3*v8*v12-v6*v1*v5*u1*v8*v12+v6*v2*u1*v8*v12-v6*v2*u2*v7*v12-v2*u2*v7*v4*v12-v2*u2*wi1*v10*v12)/(v1*v2*ipow(sqrt(v4+v3),3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v1*v5,2));
      }
    case 'c':
      if(up)
      {
        const float v1=(lwi),v2=ipow(lwo,2),v3=ipow(wi0,2),v4=ipow(wi2,2),v5=(lwo);
        return -(v1*(u2*v1*v5*wi0*ipow(wo2,2)+v1*v5*u1*wi0*wo1*wo2-v1*v5*u2*wi2*wo0*wo2+v1*v5*u0*wi0*wo0*wo2+v2*u1*wi0*wi1*wo2+v2*u0*v4*wo2+v2*u0*v3*wo2-v1*v5*u1*wi2*wo0*wo1+v2*u0*wi1*wi2*wo1-v2*u2*wi0*wi1*wo1-u0*v1*v5*wi2*ipow(wo0,2)-v2*u1*wi1*wi2*wo0-v2*u2*v4*wo0-v2*u2*v3*wo0+v1*v2*v5*u0*wi2-v1*v2*v5*u2*wi0))/(v2*sqrt(v4+v3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v1*v5,2));
      }
      else
      {
        const float v1=(lwi),v2=ipow(lwo,2),v3=ipow(wi1,2),v4=ipow(wi2,2),v5=(lwo);
        return (v1*(u2*v1*v5*wi1*ipow(wo2,2)-v1*v5*u2*wi2*wo1*wo2+v1*v5*u1*wi1*wo1*wo2+v1*v5*u0*wi1*wo0*wo2+v2*u0*wi0*wi1*wo2+v2*u1*v4*wo2+v2*u1*v3*wo2-u1*v1*v5*wi2*ipow(wo1,2)-v1*v5*u0*wi2*wo0*wo1-v2*u0*wi0*wi2*wo1-v2*u2*v4*wo1-v2*u2*v3*wo1+v2*u1*wi0*wi2*wo0-v2*u2*wi0*wi1*wo0+v1*v2*v5*u1*wi2-v1*v2*v5*u2*wi1))/(v2*sqrt(v4+v3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v1*v5,2));
      }
  }
}

static inline float manifold_vol_dhv_du(const char m, const float *wi, const float *wo, const float lwi, const float lwo, const float *u, const float scramble)
{
  const int up = fabsf(wi[1]/lwi) < scramble;
  const float wi0 = wi[0], wi1 = wi[1], wi2 = wi[2], wo0 = wo[0], wo1 = wo[1], wo2 = wo[2];
  const float u0 = u[0], u1 = u[1], u2 = u[2];
  switch(m)
  {
    case 'a':
      if(up)
      {
        const float v1=ipow(lwi,2),v2=ipow(wi0,2),v3=ipow(wi2,2),v4=(lwi),v5=(lwo),v6=ipow(wi0,3),v7=ipow(wi0,4),v8=ipow(wi1,2),v9=ipow(wi2,3),v10=ipow(wo0,2),v11=ipow(wi2,4),v12=ipow(wo1,2),v13=ipow(wo2,2);
        return -((-v1*u0*wi0*v8*wi2*wo1*wo2)-v1*u0*v6*wi2*wo1*wo2-v1*u0*wi0*v9*wo1*wo2+v1*u2*v2*v8*wo1*wo2+v1*u2*v7*wo1*wo2+v1*u2*v2*v3*wo1*wo2-2*v1*u0*v2*wi1*wi2*wo0*wo2+2*v1*u1*v6*wi2*wo0*wo2+2*v1*u1*wi0*v9*wo0*wo2-2*v1*u2*wi0*wi1*v3*wo0*wo2-v1*v4*v5*u0*wi0*wi1*wi2*wo2-v4*v5*u0*v6*wi1*wi2*wo2-v4*v5*u1*v2*v8*wi2*wo2+v1*v4*v5*u1*v2*wi2*wo2+v1*v4*v5*u2*v2*wi1*wo2-v4*v5*u0*wi0*wi1*v9*wo2-v4*v5*u1*v8*v9*wo2+v1*v4*v5*u1*v9*wo2-v4*v5*u2*v2*wi1*v3*wo2-v4*v5*u2*wi1*v11*wo2-v1*u2*wi0*v8*wi2*wo0*wo1-v1*u2*v6*wi2*wo0*wo1-v1*u2*wi0*v9*wo0*wo1+v1*u0*v8*v3*wo0*wo1+v1*u0*v2*v3*wo0*wo1+v1*u0*v11*wo0*wo1+u2*v4*v5*ipow(wi2,5)*wo1+v4*v5*u2*v7*wi2*wo1-v1*v4*v5*u2*v2*wi2*wo1+v4*v5*u1*v7*wi1*wo1+u0*v4*v5*ipow(wi0,5)*wo1+2*v4*v5*u2*v2*v9*wo1-v1*v4*v5*u2*v9*wo1-v1*v4*v5*u0*v6*wo1+2*v4*v5*u1*v2*wi1*v3*wo1-v1*v4*v5*u0*wi0*v3*wo1+2*v4*v5*u0*v6*v3*wo1+v4*v5*u1*wi1*v11*wo1+v4*v5*u0*wi0*v11*wo1-v1*v4*v5*u2*wi0*wi1*wi2*wo0-v4*v5*u2*v6*wi1*wi2*wo0-v4*v5*u0*v7*wi1*wo0-v4*v5*u2*wi0*wi1*v9*wo0-v4*v5*u1*v6*v8*wo0+v1*v4*v5*u1*v6*wo0-v4*v5*u0*v2*wi1*v3*wo0+v1*v4*v5*u0*wi1*v3*wo0+v1*v4*v5*u1*wi0*v3*wo0-v4*v5*u1*wi0*v8*v3*wo0-v1*u2*wi1*v9*v13-v1*u0*wi0*wi1*v3*v13+v1*u1*v2*v3*v13+v1*u1*v11*v13-v1*u2*v2*wi1*wi2*v12-v1*u0*v6*wi1*v12-v1*u2*wi1*v9*v12+v1*u1*v7*v12-v1*u0*wi0*wi1*v3*v12+2*v1*u1*v2*v3*v12+v1*u1*v11*v12-v1*u2*v2*wi1*wi2*v10-v1*u0*v6*wi1*v10+v1*u1*v7*v10+v1*u1*v2*v3*v10)/(v1*ipow(sqrt(v3+v2),3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v4*v5,2));
      }
      else
      {
        const float v1=ipow(lwi,2),v2=ipow(wi1,2),v3=ipow(wi2,2),v4=(lwi),v5=(lwo),v6=ipow(wi1,3),v7=ipow(wi1,4),v8=ipow(wi2,3),v9=ipow(wi2,4),v10=ipow(wo0,2),v11=ipow(wi0,2),v12=ipow(wo1,2),v13=ipow(wo2,2);
        return -(2*v1*u0*v6*wi2*wo1*wo2-2*v1*u1*wi0*v2*wi2*wo1*wo2+2*v1*u0*wi1*v8*wo1*wo2-2*v1*u2*wi0*wi1*v3*wo1*wo2-v1*u1*v11*wi1*wi2*wo0*wo2-v1*u1*v6*wi2*wo0*wo2-v1*u1*wi1*v8*wo0*wo2+v1*u2*v7*wo0*wo2+v1*u2*v2*v3*wo0*wo2+v1*u2*v11*v2*wo0*wo2-v1*v4*v5*u1*wi0*wi1*wi2*wo2-v4*v5*u1*wi0*v6*wi2*wo2-v4*v5*u0*v11*v2*wi2*wo2+v1*v4*v5*u0*v2*wi2*wo2-v4*v5*u2*wi0*v9*wo2-v4*v5*u1*wi0*wi1*v8*wo2-v4*v5*u0*v11*v8*wo2+v1*v4*v5*u0*v8*wo2-v4*v5*u2*wi0*v2*v3*wo2+v1*v4*v5*u2*wi0*v2*wo2-v1*u2*v11*wi1*wi2*wo0*wo1-v1*u2*v6*wi2*wo0*wo1+v1*u1*v9*wo0*wo1-v1*u2*wi1*v8*wo0*wo1+v1*u1*v2*v3*wo0*wo1+v1*u1*v11*v3*wo0*wo1-v1*v4*v5*u2*wi0*wi1*wi2*wo1-v4*v5*u2*wi0*v6*wi2*wo1-v4*v5*u2*wi0*wi1*v8*wo1-v4*v5*u1*wi0*v7*wo1-v4*v5*u0*v11*v6*wo1+v1*v4*v5*u0*v6*wo1-v4*v5*u0*v11*wi1*v3*wo1+v1*v4*v5*u0*wi1*v3*wo1+v1*v4*v5*u1*wi0*v3*wo1-v4*v5*u1*wi0*v2*v3*wo1+u2*v4*v5*ipow(wi2,5)*wo0+v4*v5*u2*v7*wi2*wo0-v1*v4*v5*u2*v2*wi2*wo0+u1*v4*v5*ipow(wi1,5)*wo0+v4*v5*u1*wi1*v9*wo0+v4*v5*u0*wi0*v9*wo0+2*v4*v5*u2*v2*v8*wo0-v1*v4*v5*u2*v8*wo0+v4*v5*u0*wi0*v7*wo0-v1*v4*v5*u1*v6*wo0-v1*v4*v5*u1*wi1*v3*wo0+2*v4*v5*u1*v6*v3*wo0+2*v4*v5*u0*wi0*v2*v3*wo0+v1*u0*v9*v13-v1*u2*wi0*v8*v13-v1*u1*wi0*wi1*v3*v13+v1*u0*v2*v3*v13-v1*u2*wi0*v2*wi2*v12+v1*u0*v7*v12-v1*u1*wi0*v6*v12+v1*u0*v2*v3*v12-v1*u2*wi0*v2*wi2*v10+v1*u0*v9*v10-v1*u2*wi0*v8*v10+v1*u0*v7*v10-v1*u1*wi0*v6*v10-v1*u1*wi0*wi1*v3*v10+2*v1*u0*v2*v3*v10)/(v1*ipow(sqrt(v3+v2),3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v4*v5,2));
      }
    default: case 'b':
      if(up)
      {
        const float v1=ipow(lwi,2),v2=ipow(lwo,2),v3=ipow(wi0,2),v4=ipow(wi2,2),v5=(lwi),v6=(lwo),v7=ipow(wi0,4),v8=ipow(wi0,3),v9=ipow(wi2,3),v10=ipow(wi2,4),v11=ipow(wi0,5),v12=ipow(wi1,2),v13=ipow(wo0,2),v14=ipow(wi2,5),v15=ipow(wo1,2),v16=ipow(wo2,2);
        return (v1*v2*u1*v10*v16+v1*v5*v6*u2*wi1*v9*v16-v1*v2*u2*wi1*v9*v16-v1*v2*u0*wi0*wi1*v4*v16+v1*v2*u1*v3*v4*v16+v1*v5*v6*u2*v3*wi1*wi2*v16-v1*v5*v6*u2*v10*wo1*wo2+v1*v5*v6*u1*wi1*v9*wo1*wo2-v1*v2*u0*wi0*v9*wo1*wo2-2*v1*v5*v6*u2*v3*v4*wo1*wo2+v1*v2*u2*v3*v4*wo1*wo2-v1*v2*u0*wi0*v12*wi2*wo1*wo2+v1*v5*v6*u1*v3*wi1*wi2*wo1*wo2-v1*v2*u0*v8*wi2*wo1*wo2+v1*v2*u2*v3*v12*wo1*wo2-v1*v5*v6*u2*v7*wo1*wo2+v1*v2*u2*v7*wo1*wo2+v1*v5*v6*u0*wi1*v9*wo0*wo2+2*v1*v2*u1*wi0*v9*wo0*wo2+v1*v5*v6*u2*wi0*wi1*v4*wo0*wo2-2*v1*v2*u2*wi0*wi1*v4*wo0*wo2+v1*v5*v6*u0*v3*wi1*wi2*wo0*wo2-2*v1*v2*u0*v3*wi1*wi2*wo0*wo2+2*v1*v2*u1*v8*wi2*wo0*wo2+v1*v5*v6*u2*v8*wi1*wo0*wo2+v1*v2*u1*v14*wo2-v5*v2*v6*u2*wi1*v10*wo2-v5*v2*v6*u1*v12*v9*wo2+v1*v2*u1*v12*v9*wo2-v5*v2*v6*u0*wi0*wi1*v9*wo2+2*v1*v2*u1*v3*v9*wo2+v1*v5*v2*v6*u1*v9*wo2-v5*v2*v6*u2*v3*wi1*v4*wo2-v5*v2*v6*u1*v3*v12*wi2*wo2+v1*v2*u1*v3*v12*wi2*wo2-v5*v2*v6*u0*v8*wi1*wi2*wo2-v1*v5*v2*v6*u0*wi0*wi1*wi2*wo2+v1*v2*u1*v7*wi2*wo2+v1*v5*v2*v6*u1*v3*wi2*wo2+v1*v5*v2*v6*u2*v3*wi1*wo2-v1*v5*v6*u1*v10*v15+v1*v2*u1*v10*v15-v1*v2*u2*wi1*v9*v15-v1*v2*u0*wi0*wi1*v4*v15-2*v1*v5*v6*u1*v3*v4*v15+2*v1*v2*u1*v3*v4*v15-v1*v2*u2*v3*wi1*wi2*v15-v1*v2*u0*v8*wi1*v15-v1*v5*v6*u1*v7*v15+v1*v2*u1*v7*v15-v1*v5*v6*u0*v10*wo0*wo1+v1*v2*u0*v10*wo0*wo1-v1*v2*u2*wi0*v9*wo0*wo1+v1*v2*u0*v12*v4*wo0*wo1+v1*v5*v6*u1*wi0*wi1*v4*wo0*wo1-2*v1*v5*v6*u0*v3*v4*wo0*wo1+v1*v2*u0*v3*v4*wo0*wo1-v1*v2*u2*wi0*v12*wi2*wo0*wo1-v1*v2*u2*v8*wi2*wo0*wo1+v1*v5*v6*u1*v8*wi1*wo0*wo1-v1*v5*v6*u0*v7*wo0*wo1+v5*v2*v6*u2*v14*wo1-v1*v2*u2*v14*wo1+v5*v2*v6*u1*wi1*v10*wo1+v5*v2*v6*u0*wi0*v10*wo1-v1*v2*u0*wi0*v10*wo1-v1*v2*u2*v12*v9*wo1+2*v5*v2*v6*u2*v3*v9*wo1-2*v1*v2*u2*v3*v9*wo1-v1*v5*v2*v6*u2*v9*wo1-v1*v2*u0*wi0*v12*v4*wo1+2*v5*v2*v6*u1*v3*wi1*v4*wo1+2*v5*v2*v6*u0*v8*v4*wo1-2*v1*v2*u0*v8*v4*wo1-v1*v5*v2*v6*u0*wi0*v4*wo1-v1*v2*u2*v3*v12*wi2*wo1+v5*v2*v6*u2*v7*wi2*wo1-v1*v2*u2*v7*wi2*wo1-v1*v5*v2*v6*u2*v3*wi2*wo1-v1*v2*u0*v8*v12*wo1+v5*v2*v6*u1*v7*wi1*wo1+v5*v2*v6*u0*v11*wo1-v1*v2*u0*v11*wo1-v1*v5*v2*v6*u0*v8*wo1+v1*v5*v6*u0*wi0*wi1*v4*v13+v1*v2*u1*v3*v4*v13-v1*v2*u2*v3*wi1*wi2*v13+v1*v5*v6*u0*v8*wi1*v13-v1*v2*u0*v8*wi1*v13+v1*v2*u1*v7*v13+v1*v2*u1*wi0*v10*wo0-v5*v2*v6*u2*wi0*wi1*v9*wo0-v5*v2*v6*u1*wi0*v12*v4*wo0+v1*v2*u1*wi0*v12*v4*wo0-v5*v2*v6*u0*v3*wi1*v4*wo0+v1*v5*v2*v6*u0*wi1*v4*wo0+2*v1*v2*u1*v8*v4*wo0+v1*v5*v2*v6*u1*wi0*v4*wo0-v5*v2*v6*u2*v8*wi1*wi2*wo0-v1*v5*v2*v6*u2*wi0*wi1*wi2*wo0-v5*v2*v6*u1*v8*v12*wo0+v1*v2*u1*v8*v12*wo0-v5*v2*v6*u0*v7*wi1*wo0+v1*v2*u1*v11*wo0+v1*v5*v2*v6*u1*v8*wo0+v1*v5*v2*v6*u1*v10-v1*v5*v2*v6*u2*wi1*v9-v1*v5*v2*v6*u0*wi0*wi1*v4+2*v1*v5*v2*v6*u1*v3*v4-v1*v5*v2*v6*u2*v3*wi1*wi2-v1*v5*v2*v6*u0*v8*wi1+v1*v5*v2*v6*u1*v7)/(v1*v2*ipow(sqrt(v4+v3),3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v5*v6,2));
      }
      else
      {
        const float v1=ipow(lwi,2),v2=ipow(lwo,2),v3=ipow(wi1,2),v4=ipow(wi2,2),v5=(lwi),v6=(lwo),v7=ipow(wi1,3),v8=ipow(wi1,4),v9=ipow(wi2,3),v10=ipow(wi2,4),v11=ipow(wi0,2),v12=ipow(wi1,5),v13=ipow(wi2,5),v14=ipow(wo0,2),v15=ipow(wo1,2),v16=ipow(wo2,2);
        return (v1*v2*u0*v10*v16+v1*v5*v6*u2*wi0*v9*v16-v1*v2*u2*wi0*v9*v16+v1*v2*u0*v3*v4*v16-v1*v2*u1*wi0*wi1*v4*v16+v1*v5*v6*u2*wi0*v3*wi2*v16+2*v1*v2*u0*wi1*v9*wo1*wo2+v1*v5*v6*u1*wi0*v9*wo1*wo2+v1*v5*v6*u2*wi0*wi1*v4*wo1*wo2-2*v1*v2*u2*wi0*wi1*v4*wo1*wo2+2*v1*v2*u0*v7*wi2*wo1*wo2+v1*v5*v6*u1*wi0*v3*wi2*wo1*wo2-2*v1*v2*u1*wi0*v3*wi2*wo1*wo2+v1*v5*v6*u2*wi0*v7*wo1*wo2-v1*v5*v6*u2*v10*wo0*wo2-v1*v2*u1*wi1*v9*wo0*wo2+v1*v5*v6*u0*wi0*v9*wo0*wo2-2*v1*v5*v6*u2*v3*v4*wo0*wo2+v1*v2*u2*v3*v4*wo0*wo2-v1*v2*u1*v7*wi2*wo0*wo2+v1*v5*v6*u0*wi0*v3*wi2*wo0*wo2-v1*v2*u1*v11*wi1*wi2*wo0*wo2-v1*v5*v6*u2*v8*wo0*wo2+v1*v2*u2*v8*wo0*wo2+v1*v2*u2*v11*v3*wo0*wo2+v1*v2*u0*v13*wo2-v5*v2*v6*u2*wi0*v10*wo2+2*v1*v2*u0*v3*v9*wo2-v5*v2*v6*u1*wi0*wi1*v9*wo2-v5*v2*v6*u0*v11*v9*wo2+v1*v2*u0*v11*v9*wo2+v1*v5*v2*v6*u0*v9*wo2-v5*v2*v6*u2*wi0*v3*v4*wo2+v1*v2*u0*v8*wi2*wo2-v5*v2*v6*u1*wi0*v7*wi2*wo2-v5*v2*v6*u0*v11*v3*wi2*wo2+v1*v2*u0*v11*v3*wi2*wo2+v1*v5*v2*v6*u0*v3*wi2*wo2-v1*v5*v2*v6*u1*wi0*wi1*wi2*wo2+v1*v5*v2*v6*u2*wi0*v3*wo2+v1*v2*u0*v3*v4*v15+v1*v5*v6*u1*wi0*wi1*v4*v15-v1*v2*u2*wi0*v3*wi2*v15+v1*v2*u0*v8*v15+v1*v5*v6*u1*wi0*v7*v15-v1*v2*u1*wi0*v7*v15-v1*v5*v6*u1*v10*wo0*wo1+v1*v2*u1*v10*wo0*wo1-v1*v2*u2*wi1*v9*wo0*wo1-2*v1*v5*v6*u1*v3*v4*wo0*wo1+v1*v2*u1*v3*v4*wo0*wo1+v1*v5*v6*u0*wi0*wi1*v4*wo0*wo1+v1*v2*u1*v11*v4*wo0*wo1-v1*v2*u2*v7*wi2*wo0*wo1-v1*v2*u2*v11*wi1*wi2*wo0*wo1-v1*v5*v6*u1*v8*wo0*wo1+v1*v5*v6*u0*wi0*v7*wo0*wo1+v1*v2*u0*wi1*v10*wo1-v5*v2*v6*u2*wi0*wi1*v9*wo1+2*v1*v2*u0*v7*v4*wo1-v5*v2*v6*u1*wi0*v3*v4*wo1-v5*v2*v6*u0*v11*wi1*v4*wo1+v1*v2*u0*v11*wi1*v4*wo1+v1*v5*v2*v6*u0*wi1*v4*wo1+v1*v5*v2*v6*u1*wi0*v4*wo1-v5*v2*v6*u2*wi0*v7*wi2*wo1-v1*v5*v2*v6*u2*wi0*wi1*wi2*wo1+v1*v2*u0*v12*wo1-v5*v2*v6*u1*wi0*v8*wo1-v5*v2*v6*u0*v11*v7*wo1+v1*v2*u0*v11*v7*wo1+v1*v5*v2*v6*u0*v7*wo1-v1*v5*v6*u0*v10*v14+v1*v2*u0*v10*v14-v1*v2*u2*wi0*v9*v14-2*v1*v5*v6*u0*v3*v4*v14+2*v1*v2*u0*v3*v4*v14-v1*v2*u1*wi0*wi1*v4*v14-v1*v2*u2*wi0*v3*wi2*v14-v1*v5*v6*u0*v8*v14+v1*v2*u0*v8*v14-v1*v2*u1*wi0*v7*v14+v5*v2*v6*u2*v13*wo0-v1*v2*u2*v13*wo0+v5*v2*v6*u1*wi1*v10*wo0-v1*v2*u1*wi1*v10*wo0+v5*v2*v6*u0*wi0*v10*wo0+2*v5*v2*v6*u2*v3*v9*wo0-2*v1*v2*u2*v3*v9*wo0-v1*v2*u2*v11*v9*wo0-v1*v5*v2*v6*u2*v9*wo0+2*v5*v2*v6*u1*v7*v4*wo0-2*v1*v2*u1*v7*v4*wo0+2*v5*v2*v6*u0*wi0*v3*v4*wo0-v1*v2*u1*v11*wi1*v4*wo0-v1*v5*v2*v6*u1*wi1*v4*wo0+v5*v2*v6*u2*v8*wi2*wo0-v1*v2*u2*v8*wi2*wo0-v1*v2*u2*v11*v3*wi2*wo0-v1*v5*v2*v6*u2*v3*wi2*wo0+v5*v2*v6*u1*v12*wo0-v1*v2*u1*v12*wo0+v5*v2*v6*u0*wi0*v8*wo0-v1*v2*u1*v11*v7*wo0-v1*v5*v2*v6*u1*v7*wo0+v1*v5*v2*v6*u0*v10-v1*v5*v2*v6*u2*wi0*v9+2*v1*v5*v2*v6*u0*v3*v4-v1*v5*v2*v6*u1*wi0*wi1*v4-v1*v5*v2*v6*u2*wi0*v3*wi2+v1*v5*v2*v6*u0*v8-v1*v5*v2*v6*u1*wi0*v7)/(v1*v2*ipow(sqrt(v4+v3),3)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v5*v6,2));
      }
    case 'c':
      if(up)
      {
        const float v1=ipow(lwo,2),v2=ipow(wi0,2),v3=ipow(wi2,2),v4=(lwi),v5=(lwo),v6=ipow(wi0,3),v7=ipow(wi1,2),v8=ipow(wi2,3),v9=ipow(wo1,2);
        return -(u2*v4*v5*wi1*wi2*ipow(wo2,2)+v4*v5*u1*wi1*wi2*wo1*wo2-v4*v5*u2*v3*wo1*wo2-v4*v5*u2*v2*wo1*wo2+v4*v5*u0*wi1*wi2*wo0*wo2+v4*v5*u2*wi0*wi1*wo0*wo2+v1*u1*v7*wi2*wo2+v1*u1*v2*wi2*wo2+v1*u1*v8*wo2+v4*v5*u1*wi0*wi1*wo0*wo1-v4*v5*u0*v3*wo0*wo1-v4*v5*u0*v2*wo0*wo1-v1*u2*v7*wi2*wo1-v1*u2*v2*wi2*wo1-v1*u2*v8*wo1-v1*u0*wi0*v7*wo1-v1*u0*v6*wo1-v1*u0*wi0*v3*wo1+u0*v4*v5*wi0*wi1*ipow(wo0,2)+v1*u1*wi0*v7*wo0+v1*u1*v6*wo0+v1*u1*wi0*v3*wo0-v4*v1*v5*u2*wi1*wi2-v4*v1*v5*u0*wi0*wi1-v4*v5*u1*v3*v9-v4*v5*u1*v2*v9+v4*v1*v5*u1*v3+v4*v1*v5*u1*v2)/(v1*sqrt(v3+v2)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v4*v5,2));
      }
      else
      {
        const float v1=ipow(lwo,2),v2=ipow(wi1,2),v3=ipow(wi2,2),v4=(lwi),v5=(lwo),v6=ipow(wi0,2),v7=ipow(wi1,3),v8=ipow(wi2,3),v9=ipow(wo0,2);
        return -(u2*v4*v5*wi0*wi2*ipow(wo2,2)+v4*v5*u1*wi0*wi2*wo1*wo2+v4*v5*u2*wi0*wi1*wo1*wo2+v4*v5*u0*wi0*wi2*wo0*wo2-v4*v5*u2*v3*wo0*wo2-v4*v5*u2*v2*wo0*wo2+v1*u0*v6*wi2*wo2+v1*u0*v2*wi2*wo2+v1*u0*v8*wo2+u1*v4*v5*wi0*wi1*ipow(wo1,2)+v4*v5*u0*wi0*wi1*wo0*wo1-v4*v5*u1*v3*wo0*wo1-v4*v5*u1*v2*wo0*wo1+v1*u0*v6*wi1*wo1+v1*u0*v7*wo1+v1*u0*wi1*v3*wo1-v1*u2*v6*wi2*wo0-v1*u2*v2*wi2*wo0-v1*u1*v6*wi1*wo0-v1*u2*v8*wo0-v1*u1*v7*wo0-v1*u1*wi1*v3*wo0-v4*v1*v5*u2*wi0*wi2-v4*v1*v5*u1*wi0*wi1-v4*v5*u0*v3*v9-v4*v5*u0*v2*v9+v4*v1*v5*u0*v3+v4*v1*v5*u0*v2)/(v1*sqrt(v3+v2)*ipow(wi2*wo2+wi1*wo1+wi0*wo0+v4*v5,2));
      }
  }
}
