#!/bin/bash
echo Welcome to rendering one scene once.

#sampler=ptdl
#pointsampler=halton
##scene=scenes/veach-ajar/veach-ajar.nra2
##width=1024
##height=576
#scene=scenes/box/box.nra2
#width=1024
#height=768
##max_spp=131072
#max_spp=262144
#out=${sampler}_${pointsampler}_corona

function renderScene()
{
	sampler=$1
	pointsampler=$2
	scene=$3
	width=$4
	height=$5
	max_spp=$6

	out=${sampler}_${pointsampler}_corona
	
	echo make clean...
	make clean

	echo build with sampler $sampler, pointsampler $pointsampler
	CFLAGS+=-DMAX_PATH_LENG=32 make MOD_pointsampler=$pointsampler MOD_sampler=$sampler MOD_display=null -j 8

	echo run corona with scene $scene, write to $out, resolution $width x $height, up to $max_spp spp
	./corona $scene -x $out -w $width -h $height --scr-exp -s $max_spp --batch 16 --dbor 10
}

renderScene ptdl halton scenes/box/box.nra2 1024 768 262144
renderScene bdpt halton scenes/box/box.nra2 1024 768 262144
