/*
    This file is part of corona-13.

    corona-13 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    corona-13 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with corona-13. If not, see <http://www.gnu.org/licenses/>.
*/

// TODO this is actually the qbvh with different function names and without motion blur. merge later?

#pragma once
#include "config.h"
#include "corona_common.h"
#include <stdio.h>

struct guided_bvh_t;
typedef struct guided_bvh_t guided_bvh_t;
typedef struct gmm_lobe_t gmm_lobe_t;
typedef struct path_t path_t;

// init new bvh for given primitives (don't build yet)
guided_bvh_t* guided_bvh_init(uint32_t *p, uint32_t num_prims);

// free memory
void guided_bvh_cleanup(guided_bvh_t *b);

// build bvh, with potential file backing
void guided_bvh_build(guided_bvh_t *b, const char* filename);

// returns number of overlapping prims found
uint32_t guided_bvh_lookup(
    const guided_bvh_t *const a,  // bvh struct
    const float *const x,     // lookup point for query
    uint32_t *out_primid,     // list of intersected primitives
    uint32_t max_primids);    // allocation size of this list

// get pointer to aabb buffer (to fill it before build)
float* guided_bvh_get_prim_aabb(guided_bvh_t* b);

uint64_t guided_bvh_get_size(const guided_bvh_t *b);
