#pragma once

// define for constant uniform/guiding probability
#ifndef P_UNIFORM_FIRST
#define P_UNIFORM_FIRST 0.5f
#endif

#ifndef P_UNIFORM
#define P_UNIFORM 0.5f
#endif

#define P_UNIFORM_FIXED

#ifndef P_UNIFORM_MIN
#define P_UNIFORM_MIN 0.01f
#endif

// TODO does this need to scale with scene size?
#ifndef COV_MIN_REG
#define COV_MIN_REG 1e-4 // minimum singular value
#endif

#ifndef REL_CONTRIBUTION
#define REL_CONTRIBUTION 0
#endif

// mix in bsdf sampling up until this roughness = sqrt(alpha)
#ifndef BSDF_MAX_ROUGHNESS
#define BSDF_MAX_ROUGHNESS 0.2f
#endif

#ifndef PIXEL_EST_N_MIN
#define PIXEL_EST_N_MIN 128.f
#endif

#ifndef PIXEL_EST_MIN
#define PIXEL_EST_MIN 1e-3f
#endif

#ifndef DISABLE_COND
#define DISABLE_COND 0
#endif

#ifndef SIGMA_SCALE
//#define SIGMA_SCALE 0.729f
#define SIGMA_SCALE 0.833f
//#define SIGMA_SCALE 1.f
#endif

#ifndef ENABLE_NEE
#define ENABLE_NEE 1
#endif

// enable to write additional information during learning
#ifndef WRITE_DEBUG_INFO
#define WRITE_DEBUG_INFO 0
#endif

// enable to write stats as json
#ifndef WRITE_STATS
#define WRITE_STATS 0
#endif

// 0 for triplets, 1 for pairs
#ifndef VERTEX_PAIRS
#define VERTEX_PAIRS 0
#endif

#if VERTEX_PAIRS
#define GUIDE_DIM 6
#define V2OFFSET 0
#else
#define GUIDE_DIM 9
#define V2OFFSET 3
#endif

#ifndef FIXED_PRIOR_N0
#define FIXED_PRIOR_N0 (GUIDE_DIM+1)
#endif

#ifndef EM_ITER
#define EM_ITER 256
#endif

#ifndef OCTREE_SUBDIV_THRESHOLD
#define OCTREE_SUBDIV_THRESHOLD 32768
#endif

#ifndef RESERVOIR_SAMPLE_SIZE
#define RESERVOIR_SAMPLE_SIZE 2048
#endif

#ifndef RESERVOIR_CLEAR
#define RESERVOIR_CLEAR 0
#endif

// weight decay factor after each iteration
#ifndef RESERVOIR_DECAY
#define RESERVOIR_DECAY 1.0f
#endif

#ifndef ENABLE_GMM_REDUCTION
#define ENABLE_GMM_REDUCTION 0
#endif

#ifndef ENABLE_NEIGHBOR_SPLAT
#define ENABLE_NEIGHBOR_SPLAT 1
#endif

#ifndef OCTREE_FIXED
#define OCTREE_FIXED 0
#endif

#ifndef GMM_MAX_COMPONENTS
#define GMM_MAX_COMPONENTS 128
#endif

#ifndef EM_STOP_TOL
#define EM_STOP_TOL 1e-3
#endif

#ifndef NEIGHBOR_SPLAT_RADIUS
#define NEIGHBOR_SPLAT_RADIUS 0.2f
#endif

#ifndef ENABLE_LT
#define ENABLE_LT 0
#endif

#if ENABLE_LT && (GUIDE_DIM != 9)
#error "light tracer only works with vertex triplets"
#endif

// guide light tracer (only if it is enabled)
#ifndef GUIDE_LT
#define GUIDE_LT 1
#endif

// stop light tracing after learning. set to 0 to keep light tracing.
#ifndef LT_LEARN_ONLY
#define LT_LEARN_ONLY 1
#endif

// choose threshold so we get approximately this number of leaves
// set to 0 to use the fixed OCTREE_SUBDIV_THRESHOLD
#ifndef OCTREE_LEAF_TARGET
#define OCTREE_LEAF_TARGET 300
#endif

// fixed-size stddev for lonely triplets as a factor of octree cell size
#ifndef INIT_RADIUS
#define INIT_RADIUS 0.1
#endif
