#pragma once

#include <stdint.h>

typedef struct lobe_range_t
{
  int begin;
  int end;
} lobe_range_t;

// represents gmm conditionalized to current path
typedef struct lobe_list_t
{
  lobe_range_t ranges[PATHSPACE_MAX_VERTS]; // points into lists below for a given vertex
  uint32_t allocated;
  uint32_t end;
  uint32_t *lobes; // lobe indices
  float *cdf; // cdf for choosing lobe at vertex
  int last_path_length;
} lobe_list_t;

void lobe_list_init(lobe_list_t *ll, int n);

void lobe_list_cleanup(lobe_list_t *ll);

void lobe_list_extend(lobe_list_t *ll);

void lobe_list_clear(lobe_list_t *ll);

void lobe_list_clear_entry(lobe_list_t *ll, int v);

void lobe_list_update_end(lobe_list_t *ll);

void lobe_list_shift_new_path(lobe_list_t *ll, int new_path_length);
