import numpy as np
import struct

class Mixture:
    def __init__(self, mix_raw):
        self.n_lobes = mix_raw[0]
        self.offset = mix_raw[1]
        self.octree_pos = np.array(mix_raw[2:])

    def read_from_file(f):
        mixture_format = struct.Struct(
            '=' # no alignment
            + 'I' # number of lobes
            + 'I' # offset in lobes array
            + '3f' # octree cell center
        )
        n_lobes, = struct.unpack('i', f.read(4))
        buf = f.read(n_lobes * mixture_format.size)
        mixtures_raw = mixture_format.iter_unpack(buf)
        mixtures = [Mixture(mixture_raw) for mixture_raw in mixtures_raw]
        return mixtures
