class SampleVis:
    def __init__(self):
        samples_name = 'samples'
        if samples_name in D.meshes:
            D.meshes.remove(D.meshes[samples_name])
        mesh = bpy.data.meshes.new(samples_name)
        if samples_name in D.objects:
            D.objects.remove(D.objects[samples_name])
        self.samples_obj = bpy.data.objects.new(samples_name, mesh)
        bpy.context.scene.collection.objects.link(self.samples_obj)

    def update(self, samples, aabb):
        if samples is None:
            return
        assert(guide_dim == 6)
        bm = bmesh.new()
        bm.from_mesh(self.samples_obj.data)
        bm.clear()
        shown = 0
        for s in samples:
            if np.all(s[0:3] >= aabb[0:3]) and np.all(s[0:3] <= aabb[3:6]):
                bm.verts.new(s[0:3])
                bm.verts.new(s[3:6])
                shown += 1
            if shown >= 1000:
                break
        bm.verts.ensure_lookup_table()
        for i in range(shown):
            bm.edges.new((bm.verts[2 * i], bm.verts[2 * i + 1]))
        bm.edges.ensure_lookup_table()
        bm.to_mesh(self.samples_obj.data)
        bm.free()

"""
samples_path = (scene_dir
    + scene
    +'/corona/'
    + scene
    + postfix
    + '_samples{:05d}'.format(i))
self.all_samples.append(CacheVis.read_samples(samples_path))
"""
"""
pos = np.clip(self.frame, 1, cache_iter) - 1
samples = self.all_samples[pos]
while samples is None and pos >= 0:
    samples = self.all_samples[pos]
    pos -= 1
query_aabb = self.octree.lookup_aabb(self.query_pos)
self.sample_vis.update(samples, query_aabb)
"""
"""
def read_samples(filename):
    samples = []
    sample_format = struct.Struct(
        '='
        + 'f' # target
        + '3I' # mode v2, v3 and flags
        + '9f' # vertex triplet
    ) if not guide_pairs else struct.Struct(
        '='
        + 'f' # target
        + '3I' # mode v2, v3 and flags
        + '6f' # vertex pair
    )
    if not os.path.isfile(filename):
        return None
    samples = []
    with open(filename, 'rb') as f:
        guide_dim_file, = struct.unpack('i', f.read(4))
        n_samples, = struct.unpack('I', f.read(4))
        buf = f.read(n_samples * sample_format.size)
        samples_raw = sample_format.iter_unpack(buf)
        for sample_raw in samples_raw:
            samples.append(np.array(sample_raw[4:]))
    return samples
"""
